// 
// Copyright (C) 2008 Christian Pointner, mur.at
//                    <equinox@spreadspace.org>
//
// This is free software, licensed under the GNU General Public License v2.
// See /LICENSE for more information.
//

#ifndef _MENU_H_
#define _MENU_H_

struct cmdlist_entry_struct
{
  char* command;
  struct cmdlist_entry_struct* next;
};
typedef struct cmdlist_entry_struct cmdlist_entry;

cmdlist_entry* newCommandList();
void addCommand(cmdlist_entry** first, char* cmd);
void clearCommandList(cmdlist_entry** first);
void printCommandList(cmdlist_entry* first);

enum entry_type_enum { UNKNOWN, NIL, SUBMENU, COMMAND , SHOW , DISPLAY };
typedef enum entry_type_enum entry_type;

struct menu_entry_struct
{
  entry_type type;
  char* name;

  struct menu_entry_struct* super_entry;
  struct menu_entry_struct* sub_entry;
  cmdlist_entry* cmd_list;
  char* show_cmd;

  struct menu_entry_struct* prev;
  struct menu_entry_struct* next;
};
typedef struct menu_entry_struct menu_entry; 

menu_entry* newMenuEntry();
menu_entry* getFirst(menu_entry* entry);
menu_entry* getLast(menu_entry* entry);

menu_entry* addCommandList(menu_entry** first, char* name, cmdlist_entry* cmd_list);
menu_entry* addSubCommandList(menu_entry* super, char* name, cmdlist_entry* cmd_list);

menu_entry* addNamedEntry(menu_entry** first, char* name, entry_type type);
menu_entry* addSubNamedEntry(menu_entry* super, char* name, entry_type type);

menu_entry* addShowCommand(menu_entry** first, char* name, char* cmd);
menu_entry* addSubShowCommand(menu_entry* super, char* name, char* cmd);

menu_entry* getSubEntry(menu_entry* entry);
menu_entry* getSuperEntry(menu_entry* entry);

void clearMenu(menu_entry** first);
void printMenu(menu_entry* first, int level);

#endif
