%{
// 
// Copyright (C) 2008 Christian Pointner, mur.at
//                    <equinox@spreadspace.org>
//
// This is free software, licensed under the GNU General Public License v2.
// See /LICENSE for more information.
//

#include "menu.h"
#include "parse.h"

extern int line_cnt;
%}

%option noyywrap

%%

\s*"#".*\n               line_cnt++;
"menu"                   yylval.string = strdup(yytext); return TOK_MENU;
"command"                yylval.string = strdup(yytext); return TOK_COMMAND;
"show"                   yylval.string = strdup(yytext); return TOK_SHOW;
"display"                yylval.string = strdup(yytext); return TOK_DISPLAY;
[a-zA-Z][a-zA-Z0-9]*     yylval.string = strdup(yytext); return TOK_NAME;
[^ \t{};\"\n]+           yylval.string = strdup(yytext); return TOK_WORD;
\{                       return TOK_OPEN;
\}                       return TOK_CLOSE;
\;                       return TOK_SEMICOLON;
\"                       return TOK_QUOTE;
\n                       line_cnt++;
[ \t]+                   /* ignore whitespace */;

%%

